﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using AIOUSBNet;

namespace Sample1
{
    public partial class Form1 : Form
    {
        public UInt32 DeviceIndex = AIOUSB.diOnly; // Device Index
        public readonly UInt32 numPins = 96;
        public readonly UInt32 numPorts = 12;

        // Interval Timer fou GUI update:
        static System.Windows.Forms.Timer myTimer = new System.Windows.Forms.Timer();

        // Array of controls for GUI updates:
        public CheckBox[] checkStateArray = new CheckBox[96];

        UInt16 OutMask = 0;
        byte[] Data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        private readonly byte bTristateAll = 0;

        public Form1()
        {
            InitializeComponent();
            int i = 0;

            // Array of the LED style checkboxes:
            checkStateArray[0] = checkBoxA0_1;
            checkStateArray[1] = checkBoxA0_2;
            checkStateArray[2] = checkBoxA0_3;
            checkStateArray[3] = checkBoxA0_4;
            checkStateArray[4] = checkBoxA0_5;
            checkStateArray[5] = checkBoxA0_6;
            checkStateArray[6] = checkBoxA0_7;
            checkStateArray[7] = checkBoxA0_8;
            checkStateArray[8] = checkBoxB0_9;
            checkStateArray[9] = checkBoxB0_10;
            checkStateArray[10] = checkBoxB0_11;
            checkStateArray[11] = checkBoxB0_12;
            checkStateArray[12] = checkBoxB0_13;
            checkStateArray[13] = checkBoxB0_14;
            checkStateArray[14] = checkBoxB0_15;
            checkStateArray[15] = checkBoxB0_16;
            checkStateArray[16] = checkBoxC0_17;
            checkStateArray[17] = checkBoxC0_18;
            checkStateArray[18] = checkBoxC0_19;
            checkStateArray[19] = checkBoxC0_20;
            checkStateArray[20] = checkBoxC0_21;
            checkStateArray[21] = checkBoxC0_22;
            checkStateArray[22] = checkBoxC0_23;
            checkStateArray[23] = checkBoxC0_24;

            checkStateArray[24] = checkBoxA1_25;
            checkStateArray[25] = checkBoxA1_26;
            checkStateArray[26] = checkBoxA1_27;
            checkStateArray[27] = checkBoxA1_28;
            checkStateArray[28] = checkBoxA1_29;
            checkStateArray[29] = checkBoxA1_30;
            checkStateArray[30] = checkBoxA1_31;
            checkStateArray[31] = checkBoxA1_32;
            checkStateArray[32] = checkBoxB1_33;
            checkStateArray[33] = checkBoxB1_34;
            checkStateArray[34] = checkBoxB1_35;
            checkStateArray[35] = checkBoxB1_36;
            checkStateArray[36] = checkBoxB1_37;
            checkStateArray[37] = checkBoxB1_38;
            checkStateArray[38] = checkBoxB1_39;
            checkStateArray[39] = checkBoxB1_40;
            checkStateArray[40] = checkBoxC1_41;
            checkStateArray[41] = checkBoxC1_42;
            checkStateArray[42] = checkBoxC1_43;
            checkStateArray[43] = checkBoxC1_44;
            checkStateArray[44] = checkBoxC1_45;
            checkStateArray[45] = checkBoxC1_46;
            checkStateArray[46] = checkBoxC1_47;
            checkStateArray[47] = checkBoxC1_48;

            checkStateArray[48] = checkBoxA2_49;
            checkStateArray[49] = checkBoxA2_50;
            checkStateArray[50] = checkBoxA2_51;
            checkStateArray[51] = checkBoxA2_52;
            checkStateArray[52] = checkBoxA2_53;
            checkStateArray[53] = checkBoxA2_54;
            checkStateArray[54] = checkBoxA2_55;
            checkStateArray[55] = checkBoxA2_56;
            checkStateArray[56] = checkBoxB2_57;
            checkStateArray[57] = checkBoxB2_58;
            checkStateArray[58] = checkBoxB2_59;
            checkStateArray[59] = checkBoxB2_60;
            checkStateArray[60] = checkBoxB2_61;
            checkStateArray[61] = checkBoxB2_62;
            checkStateArray[62] = checkBoxB2_63;
            checkStateArray[63] = checkBoxB2_64;
            checkStateArray[64] = checkBoxC2_65;
            checkStateArray[65] = checkBoxC2_66;
            checkStateArray[66] = checkBoxC2_67;
            checkStateArray[67] = checkBoxC2_68;
            checkStateArray[68] = checkBoxC2_69;
            checkStateArray[69] = checkBoxC2_70;
            checkStateArray[70] = checkBoxC2_71;
            checkStateArray[71] = checkBoxC2_72;

            checkStateArray[72] = checkBoxA3_73;
            checkStateArray[73] = checkBoxA3_74;
            checkStateArray[74] = checkBoxA3_75;
            checkStateArray[75] = checkBoxA3_76;
            checkStateArray[76] = checkBoxA3_77;
            checkStateArray[77] = checkBoxA3_78;
            checkStateArray[78] = checkBoxA3_79;
            checkStateArray[79] = checkBoxA3_80;
            checkStateArray[80] = checkBoxB3_81;
            checkStateArray[81] = checkBoxB3_82;
            checkStateArray[82] = checkBoxB3_83;
            checkStateArray[83] = checkBoxB3_84;
            checkStateArray[84] = checkBoxB3_85;
            checkStateArray[85] = checkBoxB3_86;
            checkStateArray[86] = checkBoxB3_87;
            checkStateArray[87] = checkBoxB3_88;
            checkStateArray[88] = checkBoxC3_89;
            checkStateArray[89] = checkBoxC3_90;
            checkStateArray[90] = checkBoxC3_91;
            checkStateArray[91] = checkBoxC3_92;
            checkStateArray[92] = checkBoxC3_93;
            checkStateArray[93] = checkBoxC3_94;
            checkStateArray[94] = checkBoxC3_95;
            checkStateArray[95] = checkBoxC3_96;

            for (i = 0; i < numPorts; i++)
                Data[i] = 0xFF;         // all "pulled up" just as a default


            AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, ref OutMask,  Data);
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            myTimer.Tick += new EventHandler(TimerEventProcessor);
            myTimer.Interval = 100;
            myTimer.Start();
            btnToOutput_Click(btnToggle0, e);
        }
        
        private void TimerEventProcessor(Object myObject, EventArgs myEventArgs)
        {
            AIOUSB.DIO_ReadAll(DeviceIndex, Data);
            for (int i = 0; i < numPins; i++)
                checkStateArray[i].Checked = ((Data[i / 8] & (1 << (i % 8))) != 0) ? true : false; // looks complicated but efficient
        }
        
        private void btnToInput_Click(object sender, EventArgs e)
        {
            Int16 iTagindex = Convert.ToInt16(((Button)sender).Tag);
            OutMask &= Convert.ToUInt16(0xFFFF & ~(1 << iTagindex ));
            ((Button)sender).Text = "Toggle to Output Mode";
            ((Button)sender).Click -= btnToInput_Click;
            ((Button)sender).Click += btnToOutput_Click;

            AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, ref OutMask, Data);
        }

        private void btnToOutput_Click(object sender, EventArgs e)
        {
            Int16 iTagindex = Convert.ToInt16(((Button)sender).Tag);
            OutMask |= Convert.ToUInt16(1 << iTagindex);
            ((Button)sender).Text = "Toggle to Input Mode";
            ((Button)sender).Click -= btnToOutput_Click;
            ((Button)sender).Click += btnToInput_Click;

            AIOUSB.DIO_Configure(DeviceIndex, bTristateAll, ref OutMask, Data);
        }

        private void checkBoxPin_Click(object sender, EventArgs e)
        {
            Int32 i = Convert.ToInt32(((CheckBox)sender).Tag);
            byte bByte = (((Data[i / 8]) & (1 << (i % 8))) != 0) ?  (byte)0 : (byte)1;

            AIOUSB.DIO_Write1(DeviceIndex, (UInt32)i, bByte);  // byte used like a bool
        }

        private void buttonStartCycle_Click(object sender, EventArgs e)
        {
            buttonStop.Enabled = true;
            buttonStartCycle.Enabled = false;
            progressBarLO.Maximum = Convert.ToInt16(textBoxLO.Text);
            progressBarLO.Value = 0;
            progressBarHI.Maximum = Convert.ToInt16(textBoxHI.Text);
            progressBarHI.Value = 0;
            progressBarCycles.Maximum = Convert.ToInt16(textBoxCycles.Text);
            progressBarCycles.Value = 0;


            timerSeconds.Enabled = true;

        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            buttonStop.Enabled = false;
            buttonStartCycle.Enabled = true;
            timerSeconds.Enabled = false;
        }

        private void textBox_SecondsValidating(object sender, CancelEventArgs e)
        {
            string errorMsg;
            if (!ValidSeconds(((TextBox)(sender)).Text, out errorMsg))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;
                ((TextBox)(sender)).Select(0, ((TextBox)(sender)).Text.Length);

                // Set the ErrorProvider error with the text to display.  
                this.errorProvider1.SetError(((TextBox)(sender)), errorMsg);

            }
        }

        private void textBox_SecondsValidated(object sender, System.EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(((TextBox)(sender)), "");
        }

        public bool ValidSeconds(string seconds, out string errorMessage)
        {
            if (seconds.Length == 0)
            {
                errorMessage = "please enter # of seconds from 1 to 99999";
                return false;
            }
            errorMessage = "";
            return true;


        }

        // Boolean flag used to determine when a character other than a number is entered. 
        private bool nonNumberEntered = false;

        // Handle the KeyDown event to determine the type of character entered into the control. 
        private void textBox_NumberOnlyKeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            // Initialize the flag to false.
            nonNumberEntered = false;

            // Determine whether the keystroke is a number from the top of the keyboard. 
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad. 
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace. 
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed. 
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }
            //If shift key was pressed, it's not a number. 
            if (Control.ModifierKeys == Keys.Shift)
            {
                nonNumberEntered = true;
            }
        }

        // This event occurs after the KeyDown event and can be used to prevent 
        // characters from entering the control. 
        private void textBox_NumberOnlyKeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            // Check for the flag being set in the KeyDown event. 
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }
        }

        private void timerSeconds_Tick(object sender, EventArgs e)
        {
            if (progressBarLO.Value < progressBarLO.Maximum)
            {
                AIOUSB.DIO_Write1(DeviceIndex, 0, 0);
                progressBarLO.Value++;
                if (progressBarLO.Value == progressBarLO.Maximum) progressBarHI.Value = 0;
            }
            else
            {
                if (progressBarHI.Value < progressBarHI.Maximum)
                {
                    AIOUSB.DIO_Write1(DeviceIndex, 0, 1);
                    progressBarHI.Value++;
                    if (progressBarHI.Value == progressBarHI.Maximum)
                    {
                        progressBarLO.Value = 0;
                        if (progressBarCycles.Value < progressBarCycles.Maximum)
                        {
                            progressBarCycles.Value++;
                            if(progressBarCycles.Value == progressBarCycles.Maximum)
                            {
                                timerSeconds.Enabled = false;
                                buttonStartCycle.Enabled = true;
                                buttonStop.Enabled = false;
                                progressBarLO.Value = 0;
                                progressBarHI.Value = 0;
                                progressBarCycles.Value = 0;

                            }
                        }
                    }

                }
            }
        }
    }
}


